//
// A sample which uses the fractal library
//
//                              by Sebastian Mihai, 2013
//

// onload method
function smOnload() {

	// point the fractal generator at the proper DOM element
	var fractal = new Fractal( "smCanvas" );
	
	// we'll generate up to this depth
	fractal.SetMaxDepth( 8 );

	// our first node will be in the centre of the canvas
	fractal.Queue().Push( new QueueItem( fractal.Width() / 2, fractal.Height() - 50, 0 ) );

	// this function will be called by the fractal generator for each node
	var delegate = function( theFractal, theQueue, node, depth ) {

		var x = node.X();
		var y = node.Y();
	
		var powerY = Math.pow( 1.3, depth+1 );
		var deltaY = 150 / (powerY);
		
		var powerX = Math.pow( 2, depth+1 );
		var deltaX = ( theFractal.Width()/2 - 10 ) / powerX;
		
		theFractal.DrawLine( x, y, x, y-deltaY );
		theFractal.DrawLine( x-deltaX, y-deltaY, x+deltaX, y-deltaY );
		
		var left = new QueueItem( x - deltaX, y - deltaY, depth+1 );
		var right = new QueueItem( x + deltaX, y - deltaY, depth+1 );
		
		theQueue.Push( left );
		theQueue.Push( right );
		
	}

	// tell fractal generator about our delegate
	fractal.SetDelegate( delegate );

	// render fractal in an progressive, animated fashion
	// ( for a direct rendering, use fractal.Render() )
	//fractal.RenderProgressively( 100 );
	fractal.Render();
}
